SystemOrganization addCategory: #'CS598rej-HW5'!
SystemOrganization addCategory: #'CS598rej-HW5-Test'!

Object subclass: #ElectronicPart
	instanceVariableNames: 'name basePrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

!ElectronicPart class methodsFor: 'instance creation' stamp: 'm3r 6/26/2008 01:47'!
name: aString price: aNumber
	^ ElectronicPart new name: aString price: aNumber
! !

!ElectronicPart methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:46'!
basePrice
	^ basePrice
! !

!ElectronicPart methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:46'!
name
	^ name
! !

!ElectronicPart methodsFor: 'initialize-release' stamp: 'm3r 6/26/2008 01:46'!
name: aString price: aNumber
	name := aString.
	basePrice := aNumber.
! !

Object subclass: #Merchant
	instanceVariableNames: 'name premiumRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

Merchant subclass: #Company
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

!Company methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:46'!
discountForCompany: aCompany

	^ aCompany premiumRate * 0.8! !

!Company methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:54'!
discountForIndividual: anIndividual
	
	^ anIndividual premiumRate * 0.95! !

!Company methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:47'!
discountForRetailer: aRetailer

	^ aRetailer premiumRate * 0.85! !

!Company methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 02:03'!
discountFrom: aSeller
	^ aSeller discountForCompany: self
! !

Merchant subclass: #Individual
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

!Individual methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 15:01'!
discountForCompany: aCompany

	self class error! !

!Individual methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:56'!
discountForIndividual: anIndividual
	
	^ anIndividual premiumRate! !

!Individual methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 15:02'!
discountForRetailer: aRetailer

	self class error! !

!Individual methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:52'!
discountFrom: aSeller
	^ aSeller discountForIndividual: self! !

!Merchant class methodsFor: 'instance creation' stamp: 'm3r 6/26/2008 01:59'!
name: aString premiumRate: aNumber
	^ self new name: aString premiumRate: aNumber
! !

!Merchant methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 01:49'!
discountForCompany: aBuyer
	self subclassResponsibility.
! !

!Merchant methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:53'!
discountForIndividual: aBuyer
	self subclassResponsibility.! !

!Merchant methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:50'!
discountForRetailer: aBuyer
	self subclassResponsibility.! !

!Merchant methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 01:49'!
discountFrom: aSeller
	self subclassResponsibility.
! !

!Merchant methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:50'!
name
	^ name
! !

!Merchant methodsFor: 'initialize-release' stamp: 'm3r 6/26/2008 01:59'!
name: aString premiumRate: aNumber
	name := aString.
	premiumRate := aNumber.
! !

!Merchant methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:59'!
premiumRate
	^ premiumRate
! !

Merchant subclass: #Retailer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

!Retailer methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 02:02'!
discountForCompany: aCompany
	^ aCompany premiumRate * 0.95
! !

!Retailer methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:55'!
discountForIndividual: anIndividual
	
	^ anIndividual premiumRate * 0.85! !

!Retailer methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:49'!
discountForRetailer: aRetailer

	^ aRetailer premiumRate * 0.9! !

!Retailer methodsFor: 'double dispatch' stamp: 'MichaelOSullivan 6/16/2012 14:48'!
discountFrom: aSeller
	
	^ aSeller discountForRetailer: self
! !

TestCase subclass: #DoubleDispatchTest
	instanceVariableNames: 'item company retailer person itemPrice corporatePremium retailPremium personalPremium'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5-Test'!

!DoubleDispatchTest methodsFor: 'running' stamp: 'm3r 6/27/2008 08:30'!
setUp
	| individualClass |
	itemPrice := 100.
	corporatePremium := 0.5.
	retailPremium := 0.6.
	personalPremium := 0.75.
	item := ElectronicPart name: 'DVD' price: itemPrice.
	company := Company name: 'Samsung' premiumRate: corporatePremium.
	retailer := Retailer name: 'Best Buy' premiumRate: retailPremium.
	(individualClass := Smalltalk classNamed: #Individual) ifNotNil:
		[person :=  individualClass name: 'Steve Jobs' premiumRate: personalPremium].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:08'!
testCompanyBuysFromCompany
	| cost |
	cost := item basePrice * (company discountFrom: company).
	self should: [cost closeTo: (itemPrice * corporatePremium * 0.80)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:10'!
testCompanyBuysFromRetailer
	| cost |
	cost := item basePrice * (company discountFrom: retailer).
	self should: [cost closeTo: (itemPrice * corporatePremium * 0.95)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 03:22'!
testDoubleDispatchIsImplemented
	Merchant withAllSubclassesDo:
		[: class | #(discountForCompany: discountForRetailer: discountFrom:) do:
			[: selector | self should: [class includesSelector: selector]]].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 03:21'!
testDoubleDispatchIsImplementedForIndividual
	Merchant withAllSubclassesDo:
		[: class | self should: [class includesSelector: #discountForIndividual:]].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:16'!
testIndividualBuys
	| cost |
	cost := item basePrice * (person discountFrom: person).
	self should: [cost closeTo: (itemPrice * personalPremium * 1.0)].
	cost := item basePrice * (person discountFrom: company).
	self should: [cost closeTo: (itemPrice * personalPremium * 0.95)].
	cost := item basePrice * (person discountFrom: retailer).
	self should: [cost closeTo: (itemPrice * personalPremium * 0.85)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 03:33'!
testIndividualSells
	self shouldnt: [person discountFrom: person] raise: Error.
	self should: [company discountFrom: person] raise: Error.
	self should: [retailer discountFrom: person] raise: Error.
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:14'!
testRetailerBuysFromCompany
	| cost |
	cost := item basePrice * (retailer discountFrom: company).
	self should: [cost closeTo: (itemPrice * retailPremium * 0.85)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:14'!
testRetailerBuysFromRetailer
	| cost |
	cost := item basePrice * (retailer discountFrom: retailer).
	self should: [cost closeTo: (itemPrice * retailPremium * 0.90)].
! !

TestCase subclass: #PayrollVacationsTest
	instanceVariableNames: 'emp day1 regularWeek'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5-Test'!

!PayrollVacationsTest commentStamp: 'MichaelOSullivan 6/16/2012 09:26' prior: 0!
Tests the vacation handling portions of the Payroll system!

!PayrollVacationsTest methodsFor: 'running' stamp: 'MichaelOSullivan 6/16/2012 11:48'!
setUp
	"This test fixture creates an Employee"

	emp := Employee new named: 'Miles Davis'.
	
	day1 := Date 
				newDay: 2
				month: 7
				year: 2012.

	regularWeek := #(#(40 0) ).! !

!PayrollVacationsTest methodsFor: 'testing' stamp: 'MichaelOSullivan 6/16/2012 12:13'!
testOvertimePayAccrual
	"This test case checks that overtime pay is ignored when calculating accrued vacation."

	| endOfWeek |
	
	endOfWeek := day1 addDays: 4.
	emp postTimeCardFor: endOfWeek hoursWorked: 50 vacation: 0.
	self assert: emp accruedVacation equals: 0.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 45 vacation: 0.
	self assert: emp accruedVacation equals: 2.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 60 vacation: 0.
	self assert: emp accruedVacation equals: 4.! !

!PayrollVacationsTest methodsFor: 'testing' stamp: 'MichaelOSullivan 6/16/2012 12:11'!
testRegularPayAccrual
	"This tests that as an employee works regualr 40-hour weeks that vacation is accrued correctly. 
	Vacation should is accrused at the rate of 2 hours for every 50 hours of regular time worked.
	This test ensures that this 2:50 ratio is cumulative"

	| endOfWeek |
	
	endOfWeek := day1 addDays: 4.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	self assert: emp accruedVacation equals: 0.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	self assert: emp accruedVacation equals: 2.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	self assert: emp accruedVacation equals: 4.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	self assert: emp accruedVacation equals: 6.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	self assert: emp accruedVacation equals: 8.! !

!PayrollVacationsTest methodsFor: 'testing' stamp: 'MichaelOSullivan 6/16/2012 12:40'!
testTakeMoreThanAccrued
	"This test case checks that the system correctly handles cases where the employee attempts to take more vacation than he has accrued."
	
	| endOfWeek |
	
	"accrue some vacation"
	endOfWeek := day1 addDays: 4.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 1.5.
	self assert: emp accruedVacation equals: -1.5.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	self assert: emp accruedVacation equals: 0.5.! !

!PayrollVacationsTest methodsFor: 'testing' stamp: 'MichaelOSullivan 6/16/2012 12:32'!
testVacationTaken
	"This test case checks that vacation time is managed accurately as an employee takes vacation time."
	
	| endOfWeek |
	
	"accrue some vacation"
	endOfWeek := day1 addDays: 4.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 40 vacation: 0.
	self assert: emp accruedVacation equals: 6.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 39 vacation: 1.
	self assert: emp accruedVacation equals: 5.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 36.8 vacation: 3.2.
	self assert: emp accruedVacation equals: 3.8.
	
	endOfWeek := day1 addDays: 7.
	emp postTimeCardFor: endOfWeek hoursWorked: 37.1 vacation: 2.9.
	self assert: emp accruedVacation equals: 0.9.! !
